import { SetDifference, Primitive } from 'utility-types';
export declare type ValueOf<T extends object> = T[keyof T];
declare type OptionalValues<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? T[K] : never;
}[keyof T];
declare type OnlyOptionalValues<T> = SetDifference<OptionalValues<T>, truthyNonCurlies>;
export declare type NestedPartialWarningStr = 'mergePartially.deep does not allow a seed object to have values on it that are optional objects. Please use mergePartially.shallow instead. See https://github.com/dgreene1/merge-partially/blob/master/whyShallowInstead.md for more information.';
declare type truthyNonCurlies = number | boolean | Date | string | symbol | Set<any> | any[] | (() => any) | null | undefined;
export declare type NoNestedOptionalObjectsDeep<T> = OnlyOptionalValues<T> extends never ? NestedPartialProblemPreventer<T> : NestedPartialWarningStr;
export declare type NoNestedOptionalOnObject<T extends object> = OnlyOptionalValues<SetDifference<ValueOf<T>, truthyNonCurlies>> extends never ? T : NestedPartialWarningStr;
export declare type NestedPartialProblemPreventer<T> = T extends ((...args: any[]) => any) | Primitive ? T : T extends DeepNoNestedOptionalArray<infer U> ? DeepNoNestedOptionalArray<U> : T extends object ? NoNestedOptionalOnObject<T> : T;
/** @private */
interface DeepNoNestedOptionalArray<T> extends ReadonlyArray<NestedPartialProblemPreventer<T>> {
}
export {};
